unit uschaltjahr;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ComCtrls;

type

  { Tfschaltjahr }

  Tfschaltjahr = class(TForm)
    BitBtn1: TBitBtn;
    b_leeren: TButton;
    b_liste: TButton;
    b_pruefe: TButton;
    e_anfang: TEdit;
    e_ende: TEdit;
    e_zahl: TEdit;
    e_ausgabe: TEdit;
    Label1: TLabel;
    lb_schaltjahre: TListBox;
    lthema: TLabel;
    memo1: TMemo;
    procedure b_leerenClick(Sender: TObject);
    procedure b_listeClick(Sender: TObject);
    procedure b_pruefeClick(Sender: TObject);
  private
    { private declarations }
    PROCEDURE Schaltjahr(z : WORD);
    PROCEDURE Schaltjahr2(z : WORD; VAR txt : STRING; VAR sj : BOOLEAN);
  public
    { public declarations }
  end;

var
  fschaltjahr: Tfschaltjahr;

implementation

{$R *.lfm}

{ Tfschaltjahr }

PROCEDURE Tfschaltjahr.Schaltjahr(z : WORD);  //globale Prozedur mit einseitiger PÜ
BEGIN
 IF z MOD 4=0 THEN
      IF z MOD 100=0  THEN
           IF z MOD 400=0 THEN e_ausgabe.text:='ist ein Schaltjahr'
                          ELSE e_ausgabe.text:='ist kein Schaltjahr'
                      ELSE e_ausgabe.text:='ist ein Schaltjahr'
              ELSE e_ausgabe.text:='ist kein Schaltjahr';
END;

PROCEDURE Tfschaltjahr.Schaltjahr2(z : WORD; VAR txt : STRING; VAR sj : BOOLEAN);  //globale Prozedur mit zweiseitiger PÜ
BEGIN
 sj:=FALSE;
 IF z MOD 4=0 THEN
      IF z MOD 100=0  THEN
           IF z MOD 400=0 THEN BEGIN txt:='ist ein Schaltjahr'; sj:=TRUE; END
                          ELSE txt:='ist kein Schaltjahr'
                      ELSE BEGIN txt:='ist ein Schaltjahr'; sj:=TRUE; END
              ELSE txt:='ist kein Schaltjahr';
END;

procedure Tfschaltjahr.b_pruefeClick(Sender: TObject);
VAR zahl : WORD;
begin
  //Eingabe
    zahl := STRTOINT(e_zahl.text);
  //Verarbeitung
    Schaltjahr(zahl);
end;

procedure Tfschaltjahr.b_listeClick(Sender: TObject);
VAR a,e,j : WORD;
    meldung : STRING;
    istsj : BOOLEAN;
begin
 //Initialisierung
   meldung := '';
   memo1.lines[0]:='Liste aller Schaltjahre:';
   istsj:=FALSE;
 //Eingabe
   a := STRTOINT(e_anfang.text);
   e := STRTOINT(e_ende.text);
 //Verarbeitung
   FOR j:=a TO e DO
    BEGIN
      Schaltjahr2(j,meldung,istsj);
      lb_schaltjahre.items.add(INTTOSTR(j) + ': ' + meldung);
      IF istsj THEN memo1.text := memo1.text + INTTOSTR(j) + ' ';
    END;
end;

procedure Tfschaltjahr.b_leerenClick(Sender: TObject);
begin
  lb_schaltjahre.clear;
  memo1.Clear;
end;



end.

